// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// PostTemplatesReader is a Reader for the PostTemplates structure.
type PostTemplatesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTemplatesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTemplatesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTemplatesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTemplatesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTemplatesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTemplatesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTemplatesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostTemplatesOK creates a PostTemplatesOK with default headers values
func NewPostTemplatesOK() *PostTemplatesOK {
	return &PostTemplatesOK{}
}

/*
PostTemplatesOK describes a response with status code 200, with default header values.

Response with Template objects
*/
type PostTemplatesOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.TemplateResponse
}

// IsSuccess returns true when this post templates o k response has a 2xx status code
func (o *PostTemplatesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post templates o k response has a 3xx status code
func (o *PostTemplatesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates o k response has a 4xx status code
func (o *PostTemplatesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post templates o k response has a 5xx status code
func (o *PostTemplatesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post templates o k response a status code equal to that given
func (o *PostTemplatesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post templates o k response
func (o *PostTemplatesOK) Code() int {
	return 200
}

func (o *PostTemplatesOK) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesOK  %+v", 200, o.Payload)
}

func (o *PostTemplatesOK) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesOK  %+v", 200, o.Payload)
}

func (o *PostTemplatesOK) GetPayload() *devops_models.TemplateResponse {
	return o.Payload
}

func (o *PostTemplatesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.TemplateResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTemplatesUnauthorized creates a PostTemplatesUnauthorized with default headers values
func NewPostTemplatesUnauthorized() *PostTemplatesUnauthorized {
	return &PostTemplatesUnauthorized{}
}

/*
PostTemplatesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostTemplatesUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post templates unauthorized response has a 2xx status code
func (o *PostTemplatesUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post templates unauthorized response has a 3xx status code
func (o *PostTemplatesUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates unauthorized response has a 4xx status code
func (o *PostTemplatesUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post templates unauthorized response has a 5xx status code
func (o *PostTemplatesUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post templates unauthorized response a status code equal to that given
func (o *PostTemplatesUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post templates unauthorized response
func (o *PostTemplatesUnauthorized) Code() int {
	return 401
}

func (o *PostTemplatesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTemplatesUnauthorized) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTemplatesUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostTemplatesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTemplatesForbidden creates a PostTemplatesForbidden with default headers values
func NewPostTemplatesForbidden() *PostTemplatesForbidden {
	return &PostTemplatesForbidden{}
}

/*
PostTemplatesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostTemplatesForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post templates forbidden response has a 2xx status code
func (o *PostTemplatesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post templates forbidden response has a 3xx status code
func (o *PostTemplatesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates forbidden response has a 4xx status code
func (o *PostTemplatesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post templates forbidden response has a 5xx status code
func (o *PostTemplatesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post templates forbidden response a status code equal to that given
func (o *PostTemplatesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post templates forbidden response
func (o *PostTemplatesForbidden) Code() int {
	return 403
}

func (o *PostTemplatesForbidden) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesForbidden  %+v", 403, o.Payload)
}

func (o *PostTemplatesForbidden) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesForbidden  %+v", 403, o.Payload)
}

func (o *PostTemplatesForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostTemplatesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTemplatesNotFound creates a PostTemplatesNotFound with default headers values
func NewPostTemplatesNotFound() *PostTemplatesNotFound {
	return &PostTemplatesNotFound{}
}

/*
PostTemplatesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostTemplatesNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post templates not found response has a 2xx status code
func (o *PostTemplatesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post templates not found response has a 3xx status code
func (o *PostTemplatesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates not found response has a 4xx status code
func (o *PostTemplatesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post templates not found response has a 5xx status code
func (o *PostTemplatesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post templates not found response a status code equal to that given
func (o *PostTemplatesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post templates not found response
func (o *PostTemplatesNotFound) Code() int {
	return 404
}

func (o *PostTemplatesNotFound) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesNotFound  %+v", 404, o.Payload)
}

func (o *PostTemplatesNotFound) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesNotFound  %+v", 404, o.Payload)
}

func (o *PostTemplatesNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostTemplatesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTemplatesUnprocessableEntity creates a PostTemplatesUnprocessableEntity with default headers values
func NewPostTemplatesUnprocessableEntity() *PostTemplatesUnprocessableEntity {
	return &PostTemplatesUnprocessableEntity{}
}

/*
PostTemplatesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTemplatesUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post templates unprocessable entity response has a 2xx status code
func (o *PostTemplatesUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post templates unprocessable entity response has a 3xx status code
func (o *PostTemplatesUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates unprocessable entity response has a 4xx status code
func (o *PostTemplatesUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post templates unprocessable entity response has a 5xx status code
func (o *PostTemplatesUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post templates unprocessable entity response a status code equal to that given
func (o *PostTemplatesUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post templates unprocessable entity response
func (o *PostTemplatesUnprocessableEntity) Code() int {
	return 422
}

func (o *PostTemplatesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTemplatesUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTemplatesUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostTemplatesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTemplatesInternalServerError creates a PostTemplatesInternalServerError with default headers values
func NewPostTemplatesInternalServerError() *PostTemplatesInternalServerError {
	return &PostTemplatesInternalServerError{}
}

/*
PostTemplatesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostTemplatesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this post templates internal server error response has a 2xx status code
func (o *PostTemplatesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post templates internal server error response has a 3xx status code
func (o *PostTemplatesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post templates internal server error response has a 4xx status code
func (o *PostTemplatesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post templates internal server error response has a 5xx status code
func (o *PostTemplatesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post templates internal server error response a status code equal to that given
func (o *PostTemplatesInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post templates internal server error response
func (o *PostTemplatesInternalServerError) Code() int {
	return 500
}

func (o *PostTemplatesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTemplatesInternalServerError) String() string {
	return fmt.Sprintf("[POST /templates][%d] postTemplatesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTemplatesInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostTemplatesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
