// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetUsersObservableReader is a Reader for the GetUsersObservable structure.
type GetUsersObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUsersObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetUsersObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetUsersObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetUsersObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetUsersObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetUsersObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetUsersObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetUsersObservableOK creates a GetUsersObservableOK with default headers values
func NewGetUsersObservableOK() *GetUsersObservableOK {
	return &GetUsersObservableOK{}
}

/*
GetUsersObservableOK describes a response with status code 200, with default header values.

Simple User record response
*/
type GetUsersObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.User
}

// IsSuccess returns true when this get users observable o k response has a 2xx status code
func (o *GetUsersObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get users observable o k response has a 3xx status code
func (o *GetUsersObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable o k response has a 4xx status code
func (o *GetUsersObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get users observable o k response has a 5xx status code
func (o *GetUsersObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get users observable o k response a status code equal to that given
func (o *GetUsersObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get users observable o k response
func (o *GetUsersObservableOK) Code() int {
	return 200
}

func (o *GetUsersObservableOK) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableOK  %+v", 200, o.Payload)
}

func (o *GetUsersObservableOK) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableOK  %+v", 200, o.Payload)
}

func (o *GetUsersObservableOK) GetPayload() []*devops_models.User {
	return o.Payload
}

func (o *GetUsersObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUsersObservableUnauthorized creates a GetUsersObservableUnauthorized with default headers values
func NewGetUsersObservableUnauthorized() *GetUsersObservableUnauthorized {
	return &GetUsersObservableUnauthorized{}
}

/*
GetUsersObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetUsersObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get users observable unauthorized response has a 2xx status code
func (o *GetUsersObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get users observable unauthorized response has a 3xx status code
func (o *GetUsersObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable unauthorized response has a 4xx status code
func (o *GetUsersObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get users observable unauthorized response has a 5xx status code
func (o *GetUsersObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get users observable unauthorized response a status code equal to that given
func (o *GetUsersObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get users observable unauthorized response
func (o *GetUsersObservableUnauthorized) Code() int {
	return 401
}

func (o *GetUsersObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetUsersObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetUsersObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetUsersObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUsersObservableForbidden creates a GetUsersObservableForbidden with default headers values
func NewGetUsersObservableForbidden() *GetUsersObservableForbidden {
	return &GetUsersObservableForbidden{}
}

/*
GetUsersObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetUsersObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get users observable forbidden response has a 2xx status code
func (o *GetUsersObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get users observable forbidden response has a 3xx status code
func (o *GetUsersObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable forbidden response has a 4xx status code
func (o *GetUsersObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get users observable forbidden response has a 5xx status code
func (o *GetUsersObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get users observable forbidden response a status code equal to that given
func (o *GetUsersObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get users observable forbidden response
func (o *GetUsersObservableForbidden) Code() int {
	return 403
}

func (o *GetUsersObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetUsersObservableForbidden) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetUsersObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetUsersObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUsersObservableNotFound creates a GetUsersObservableNotFound with default headers values
func NewGetUsersObservableNotFound() *GetUsersObservableNotFound {
	return &GetUsersObservableNotFound{}
}

/*
GetUsersObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetUsersObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get users observable not found response has a 2xx status code
func (o *GetUsersObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get users observable not found response has a 3xx status code
func (o *GetUsersObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable not found response has a 4xx status code
func (o *GetUsersObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get users observable not found response has a 5xx status code
func (o *GetUsersObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get users observable not found response a status code equal to that given
func (o *GetUsersObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get users observable not found response
func (o *GetUsersObservableNotFound) Code() int {
	return 404
}

func (o *GetUsersObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetUsersObservableNotFound) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetUsersObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetUsersObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUsersObservableUnprocessableEntity creates a GetUsersObservableUnprocessableEntity with default headers values
func NewGetUsersObservableUnprocessableEntity() *GetUsersObservableUnprocessableEntity {
	return &GetUsersObservableUnprocessableEntity{}
}

/*
GetUsersObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetUsersObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get users observable unprocessable entity response has a 2xx status code
func (o *GetUsersObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get users observable unprocessable entity response has a 3xx status code
func (o *GetUsersObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable unprocessable entity response has a 4xx status code
func (o *GetUsersObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get users observable unprocessable entity response has a 5xx status code
func (o *GetUsersObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get users observable unprocessable entity response a status code equal to that given
func (o *GetUsersObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get users observable unprocessable entity response
func (o *GetUsersObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetUsersObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetUsersObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetUsersObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetUsersObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUsersObservableInternalServerError creates a GetUsersObservableInternalServerError with default headers values
func NewGetUsersObservableInternalServerError() *GetUsersObservableInternalServerError {
	return &GetUsersObservableInternalServerError{}
}

/*
GetUsersObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetUsersObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get users observable internal server error response has a 2xx status code
func (o *GetUsersObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get users observable internal server error response has a 3xx status code
func (o *GetUsersObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get users observable internal server error response has a 4xx status code
func (o *GetUsersObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get users observable internal server error response has a 5xx status code
func (o *GetUsersObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get users observable internal server error response a status code equal to that given
func (o *GetUsersObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get users observable internal server error response
func (o *GetUsersObservableInternalServerError) Code() int {
	return 500
}

func (o *GetUsersObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUsersObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /users/observable][%d] getUsersObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUsersObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetUsersObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
