// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetResearchProjectTopicsParams creates a new GetResearchProjectTopicsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetResearchProjectTopicsParams() *GetResearchProjectTopicsParams {
	return &GetResearchProjectTopicsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetResearchProjectTopicsParamsWithTimeout creates a new GetResearchProjectTopicsParams object
// with the ability to set a timeout on a request.
func NewGetResearchProjectTopicsParamsWithTimeout(timeout time.Duration) *GetResearchProjectTopicsParams {
	return &GetResearchProjectTopicsParams{
		timeout: timeout,
	}
}

// NewGetResearchProjectTopicsParamsWithContext creates a new GetResearchProjectTopicsParams object
// with the ability to set a context for a request.
func NewGetResearchProjectTopicsParamsWithContext(ctx context.Context) *GetResearchProjectTopicsParams {
	return &GetResearchProjectTopicsParams{
		Context: ctx,
	}
}

// NewGetResearchProjectTopicsParamsWithHTTPClient creates a new GetResearchProjectTopicsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetResearchProjectTopicsParamsWithHTTPClient(client *http.Client) *GetResearchProjectTopicsParams {
	return &GetResearchProjectTopicsParams{
		HTTPClient: client,
	}
}

/*
GetResearchProjectTopicsParams contains all the parameters to send to the API endpoint

	for the get research project topics operation.

	Typically these are written to a http.Request.
*/
type GetResearchProjectTopicsParams struct {

	/* ID.

	   Unique Record ID
	*/
	ID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get research project topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetResearchProjectTopicsParams) WithDefaults() *GetResearchProjectTopicsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get research project topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetResearchProjectTopicsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithTimeout(timeout time.Duration) *GetResearchProjectTopicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithContext(ctx context.Context) *GetResearchProjectTopicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithHTTPClient(client *http.Client) *GetResearchProjectTopicsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithID(id *string) *GetResearchProjectTopicsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetID(id *string) {
	o.ID = id
}

// WithLimit adds the limit to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithLimit(limit *int64) *GetResearchProjectTopicsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get research project topics params
func (o *GetResearchProjectTopicsParams) WithOffset(offset *int64) *GetResearchProjectTopicsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get research project topics params
func (o *GetResearchProjectTopicsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetResearchProjectTopicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
