// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package sfgate_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/accounts"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/assets"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/clusters"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/company_products"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/contacts"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/contracts"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/databases"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/factors"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/financial_statements"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/industries"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/industry_companies"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/industry_products"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/observations"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/roles"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/templates"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/tenants"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/topics"
	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_client/users"
)

// Default sfgate HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "sf-gate.vernonkeenan.com:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new sfgate HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Sfgate {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new sfgate HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Sfgate {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new sfgate client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Sfgate {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Sfgate)
	cli.Transport = transport
	cli.Accounts = accounts.New(transport, formats)
	cli.Assets = assets.New(transport, formats)
	cli.Clusters = clusters.New(transport, formats)
	cli.CompanyProducts = company_products.New(transport, formats)
	cli.Contacts = contacts.New(transport, formats)
	cli.Contracts = contracts.New(transport, formats)
	cli.Databases = databases.New(transport, formats)
	cli.Factors = factors.New(transport, formats)
	cli.FinancialStatements = financial_statements.New(transport, formats)
	cli.Industries = industries.New(transport, formats)
	cli.IndustryCompanies = industry_companies.New(transport, formats)
	cli.IndustryProducts = industry_products.New(transport, formats)
	cli.Observations = observations.New(transport, formats)
	cli.Roles = roles.New(transport, formats)
	cli.Templates = templates.New(transport, formats)
	cli.Tenants = tenants.New(transport, formats)
	cli.Topics = topics.New(transport, formats)
	cli.Users = users.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Sfgate is a client for sfgate
type Sfgate struct {
	Accounts accounts.ClientService

	Assets assets.ClientService

	Clusters clusters.ClientService

	CompanyProducts company_products.ClientService

	Contacts contacts.ClientService

	Contracts contracts.ClientService

	Databases databases.ClientService

	Factors factors.ClientService

	FinancialStatements financial_statements.ClientService

	Industries industries.ClientService

	IndustryCompanies industry_companies.ClientService

	IndustryProducts industry_products.ClientService

	Observations observations.ClientService

	Roles roles.ClientService

	Templates templates.ClientService

	Tenants tenants.ClientService

	Topics topics.ClientService

	Users users.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Sfgate) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Accounts.SetTransport(transport)
	c.Assets.SetTransport(transport)
	c.Clusters.SetTransport(transport)
	c.CompanyProducts.SetTransport(transport)
	c.Contacts.SetTransport(transport)
	c.Contracts.SetTransport(transport)
	c.Databases.SetTransport(transport)
	c.Factors.SetTransport(transport)
	c.FinancialStatements.SetTransport(transport)
	c.Industries.SetTransport(transport)
	c.IndustryCompanies.SetTransport(transport)
	c.IndustryProducts.SetTransport(transport)
	c.Observations.SetTransport(transport)
	c.Roles.SetTransport(transport)
	c.Templates.SetTransport(transport)
	c.Tenants.SetTransport(transport)
	c.Topics.SetTransport(transport)
	c.Users.SetTransport(transport)
}
